VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dijkstra's Graph Based Path Finding"
   ClientHeight    =   6720
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9750
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   448
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   650
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdBenchmark 
      Caption         =   "Benchmark"
      Height          =   375
      Left            =   1920
      TabIndex        =   9
      Top             =   6000
      Width           =   1455
   End
   Begin VB.Frame Frame1 
      Caption         =   "Details:"
      Height          =   1455
      Left            =   7080
      TabIndex        =   5
      Top             =   5160
      Width           =   2655
      Begin VB.Label lblTmpVar 
         AutoSize        =   -1  'True
         Caption         =   "Temp Var:"
         Height          =   210
         Left            =   120
         TabIndex        =   8
         Top             =   720
         Width           =   960
      End
      Begin VB.Label lblVisitDistance 
         AutoSize        =   -1  'True
         Caption         =   "Distance:"
         Height          =   210
         Left            =   120
         TabIndex        =   7
         Top             =   480
         Width           =   885
      End
      Begin VB.Label lblVisitNumber 
         AutoSize        =   -1  'True
         Caption         =   "Visit Number:"
         Height          =   210
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1260
      End
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Go Search!"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   6000
      Width           =   1695
   End
   Begin VB.PictureBox picMain 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFC0C0&
      DrawWidth       =   3
      FillColor       =   &H0080C0FF&
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4905
      Left            =   120
      Picture         =   "frmMain.frx":0442
      ScaleHeight     =   323
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   636
      TabIndex        =   0
      Top             =   120
      Width           =   9600
      Begin VB.Shape shpDestNode 
         BorderColor     =   &H0080FF80&
         BorderWidth     =   3
         Height          =   360
         Left            =   2640
         Top             =   2400
         Width           =   360
      End
      Begin VB.Shape shpSourceNode 
         BorderColor     =   &H008080FF&
         BorderWidth     =   3
         FillColor       =   &H00C0FFFF&
         Height          =   360
         Left            =   2880
         Top             =   480
         Width           =   360
      End
   End
   Begin VB.Label lblmisc 
      Caption         =   "Application designed and written by Jack Hoxley, January 24/25th 2001"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   6480
      Width           =   6855
   End
   Begin VB.Label lblPath 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Path: ??"
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   120
      TabIndex        =   3
      Top             =   5760
      Width           =   960
   End
   Begin VB.Label lblClosestDest 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Clostest Node To Dest: ??"
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   120
      TabIndex        =   2
      Top             =   5520
      Width           =   3000
   End
   Begin VB.Label lblClosestSrc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Closest Node To Src: ??"
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   120
      TabIndex        =   1
      Top             =   5280
      Width           =   2760
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'###############################################
'
'           NAME: VB implementation of Dijkstara's Path Finding Algorithm
'           AUTHOR: Jack Hoxley
'           WRITTEN: 24th-25th January 2001
'
'           CONTACT: Jollyjeffers@Greenonions.netscapeonline.co.uk
'                            http://www.vbexplorer.com/directx4vb/
'
'###############################################

Option Explicit

'//Basic 2D Point structure
Private Type NodePoint
    X As Long
    Y As Long
End Type

Private Const nNodes As Long = 40
Dim NodeList(0 To nNodes - 1) As NodePoint

'//A structure that connects everything up
Private Type TreeNode
    CurrNode As Long '//Pointer to an entry in the NodePoint Structure
    NextNode(0 To 3) As Long '//Pointer to 4 attached nodes
    Dist(0 To 3) As Double '//The weight of the arc CurrNode - NextNode(n)
    '## DIJKSTRAs ALGORITHM ##
    VisitNumber As Long '//What order was this node visited
    Distance As Double '//What the current distance was at this point
    TmpVar As Double '//Temporary area for storing distance data...
End Type

Dim TreeNodeList(0 To nNodes - 1) As TreeNode

Dim nPathList As Long '//How many entries are in our path...
Dim PATHLIST() As Long '//A list of the nodes we need to use to traverse between the source and destination

Dim CurrDestNode As Long
Dim CurrSrcNode As Long

Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long

Private Function DijkstraPathFinding(NodeSrc As Long, NodeDest As Long) As Boolean
'//0. Any variables required
    Dim I As Long
    Dim bRunning As Boolean
    Dim CurrentVisitNumber As Long '//Which visit the current node will be
    Dim CurrNode As Long '//Which node we are scanning...
    Dim LowestNodeFound As Long '//For when we are searching for the lowest temporary value
    Dim LowestValFound As Double '//For above variable
    
    If NodeSrc = NodeDest Then
        'we're already there...
        nPathList = 2
        ReDim PATHLIST(2) As Long
        PATHLIST(1) = NodeSrc
        PATHLIST(2) = NodeDest
        DijkstraPathFinding = True
        Exit Function
    End If

'//1. Setup all the data we need
    For I = 0 To nNodes - 1
        TreeNodeList(I).VisitNumber = -1 '//-1 indicates not visited
        TreeNodeList(I).Distance = -1 '//Unknown distance
        TreeNodeList(I).TmpVar = 99999 '//A high number that can easily be beaten
    Next I
    
    '//Set the first variable
    TreeNodeList(NodeSrc).VisitNumber = 1
        CurrentVisitNumber = 1 '//Initialise
        CurrNode = NodeSrc
    TreeNodeList(NodeSrc).Distance = 0
    TreeNodeList(NodeSrc).TmpVar = 0

'//2. Start scanning
    'We're going to keep looping till we find the destination
    Do While bRunning = False
        '//2a. Go to each node that the current one touches
                'and make it's temporary variable = source distance + weight of the arc
                If Not (TreeNodeList(CurrNode).NextNode(0) = -1) Then TreeNodeList(TreeNodeList(CurrNode).NextNode(0)).TmpVar = MIN(TreeNodeList(CurrNode).Dist(0) + TreeNodeList(CurrNode).Distance, TreeNodeList(TreeNodeList(CurrNode).NextNode(0)).TmpVar)
                If Not (TreeNodeList(CurrNode).NextNode(1) = -1) Then TreeNodeList(TreeNodeList(CurrNode).NextNode(1)).TmpVar = MIN(TreeNodeList(CurrNode).Dist(1) + TreeNodeList(CurrNode).Distance, TreeNodeList(TreeNodeList(CurrNode).NextNode(1)).TmpVar)
                If Not (TreeNodeList(CurrNode).NextNode(2) = -1) Then TreeNodeList(TreeNodeList(CurrNode).NextNode(2)).TmpVar = MIN(TreeNodeList(CurrNode).Dist(2) + TreeNodeList(CurrNode).Distance, TreeNodeList(TreeNodeList(CurrNode).NextNode(2)).TmpVar)
                If Not (TreeNodeList(CurrNode).NextNode(3) = -1) Then TreeNodeList(TreeNodeList(CurrNode).NextNode(3)).TmpVar = MIN(TreeNodeList(CurrNode).Dist(3) + TreeNodeList(CurrNode).Distance, TreeNodeList(TreeNodeList(CurrNode).NextNode(3)).TmpVar)
                
        '//2b. Decide which node has the lowest temporary variable (Free choice if multiple)
                LowestValFound = 100999 'Hopefully the graph isn't this big :)
                For I = 0 To nNodes - 1 '//If we have more than 1000-2000 nodes this part will be horribly slow...
                    If (TreeNodeList(I).TmpVar <= LowestValFound) And (TreeNodeList(I).TmpVar >= 0) And (TreeNodeList(I).VisitNumber < 0) Then 'make sure we ignore the -1's and visited nodes
                        'We have a new lowest value
                        LowestValFound = TreeNodeList(I).TmpVar
                        LowestNodeFound = I
                    End If
                Next I
                '**NB: If there are multiple lowest values then this method will choose the last one found...
        
        '//2c. Mark this node with the next visit number and copy the tmpvar -> distance
                CurrentVisitNumber = CurrentVisitNumber + 1
                TreeNodeList(LowestNodeFound).VisitNumber = CurrentVisitNumber
                TreeNodeList(LowestNodeFound).Distance = TreeNodeList(LowestNodeFound).TmpVar
                CurrNode = LowestNodeFound '//Copy the variable for next time...
        
        '//2d. If this node IS NOT the destination then go onto the next iteration...
                If CurrNode = NodeDest Then
                    bRunning = True '//We've gotten to the destination
                Else
                    bRunning = False '//Still not there yet
                End If
    Loop
    
'//3. Work out the route that was taken...
    bRunning = False
    CurrNode = NodeDest '//Start at the end, and work backwards...
    Dim lngTimeTaken As Long
    lngTimeTaken = GetTickCount
    
    nPathList = 1
    ReDim PATHLIST(nPathList) As Long
    PATHLIST(1) = NodeDest '//Put the first node in...
    
        Do While bRunning = False
            '//First we check that the current node isn't actually the start
                'because if it is then we've found the path already
                If CurrNode = NodeSrc Then
                    bRunning = True
                    GoTo SkipToEnd:
                ElseIf GetTickCount - lngTimeTaken > 1000 Then
                    'Break out if we haven't found a solution in under 1 second
                    bRunning = True
                    DijkstraPathFinding = False
                    Exit Function
                    GoTo SkipToEnd:
                End If
        
            '//Scan through each node that we visited
            If (TreeNodeList(CurrNode).NextNode(0) >= 0) Then '//Only if there is a node in this direction
                If (TreeNodeList(TreeNodeList(CurrNode).NextNode(0)).VisitNumber >= 0) Then '//Only if we visited this node...
                    If TreeNodeList(CurrNode).Distance - TreeNodeList(TreeNodeList(CurrNode).NextNode(0)).Distance = TreeNodeList(CurrNode).Dist(0) Then
                        'NextNode(0) is part of the route home
                            nPathList = nPathList + 1
                            ReDim Preserve PATHLIST(nPathList) As Long
                            PATHLIST(nPathList) = TreeNodeList(CurrNode).NextNode(0)
                            CurrNode = TreeNodeList(CurrNode).NextNode(0)
                            GoTo SkipToEnd:
                    End If
                End If
            End If
            
            If (TreeNodeList(CurrNode).NextNode(1) >= 0) Then  '//Only if there is a node in this direction
                If (TreeNodeList(TreeNodeList(CurrNode).NextNode(1)).VisitNumber >= 0) Then  '//Only if we visited this node...
                    If TreeNodeList(CurrNode).Distance - TreeNodeList(TreeNodeList(CurrNode).NextNode(1)).Distance = TreeNodeList(CurrNode).Dist(1) Then
                        'NextNode(1) is part of the route home
                            nPathList = nPathList + 1
                            ReDim Preserve PATHLIST(nPathList) As Long
                            PATHLIST(nPathList) = TreeNodeList(CurrNode).NextNode(1)
                            CurrNode = TreeNodeList(CurrNode).NextNode(1)
                            GoTo SkipToEnd:
                    End If
                End If
            End If
            
            If (TreeNodeList(CurrNode).NextNode(2) >= 0) Then  '//Only if there is a node in this direction
                If (TreeNodeList(TreeNodeList(CurrNode).NextNode(2)).VisitNumber >= 0) Then  '//Only if we visited this node...
                    If TreeNodeList(CurrNode).Distance - TreeNodeList(TreeNodeList(CurrNode).NextNode(2)).Distance = TreeNodeList(CurrNode).Dist(2) Then
                        'NextNode(2) is part of the route home
                            nPathList = nPathList + 1
                            ReDim Preserve PATHLIST(nPathList) As Long
                            PATHLIST(nPathList) = TreeNodeList(CurrNode).NextNode(2)
                            CurrNode = TreeNodeList(CurrNode).NextNode(2)
                            GoTo SkipToEnd:
                    End If
                End If
            End If
            
            If (TreeNodeList(CurrNode).NextNode(3) >= 0) Then  '//Only if there is a node in this direction
                If (TreeNodeList(TreeNodeList(CurrNode).NextNode(3)).VisitNumber >= 0) Then  '//Only if we visited this node...
                    If TreeNodeList(CurrNode).Distance - TreeNodeList(TreeNodeList(CurrNode).NextNode(3)).Distance = TreeNodeList(CurrNode).Dist(3) Then
                        'NextNode(3) is part of the route home
                            nPathList = nPathList + 1
                            ReDim Preserve PATHLIST(nPathList) As Long
                            PATHLIST(nPathList) = TreeNodeList(CurrNode).NextNode(3)
                            CurrNode = TreeNodeList(CurrNode).NextNode(3)
                            GoTo SkipToEnd:
                    End If
                End If
            End If
            
SkipToEnd:
            
        Loop
        
'//For ease of use we're going to invert the array.
    'currently we go Dest-Source, Source-Dest is more useful/easier
    Dim TmpArray() As Long
    ReDim TmpArray(nPathList) As Long
    For I = nPathList To 1 Step -1
        TmpArray(I) = PATHLIST(((nPathList - I) + 1))
    Next I
    For I = 1 To nPathList
        PATHLIST(I) = TmpArray(I)
    Next I
    
DijkstraPathFinding = True
End Function

Public Function MIN(A As Double, B As Double) As Double
    '//Return the minimum of the two...
    If A < B Then MIN = A
    If A > B Then MIN = B
    If A = B Then MIN = A
End Function

Private Sub DrawShortestPath()
    '//This function draws a big red line for our path...
    Dim I As Long
    picMain.DrawWidth = 4
    
    For I = 1 To (nPathList - 1) '//Cycle through each one...
        picMain.Line (NodeList(TreeNodeList(PATHLIST(I)).CurrNode).X, NodeList(TreeNodeList(PATHLIST(I)).CurrNode).Y)-(NodeList(TreeNodeList(PATHLIST(I + 1)).CurrNode).X, NodeList(TreeNodeList(PATHLIST(I + 1)).CurrNode).Y), RGB(255, 0, 0)
    Next I
End Sub


'//Returns the index of the closest node to the provided coordinates
Private Function ScanForNearestNode(X As Long, Y As Long) As Long
    Dim I As Long
    Dim CurrClosestIndex As Long '//Which node is currently closest
    Dim CurrClosestDist As Long '//How far away the current closest is...
    CurrClosestDist = 99999 '//Give it a number it'll beat...
    
For I = 0 To nNodes - 1
    If GetDist2D(NodeList(I).X, NodeList(I).Y, X, Y) < CurrClosestDist Then
        CurrClosestDist = GetDist2D(NodeList(I).X, NodeList(I).Y, X, Y)
        CurrClosestIndex = I
    End If
Next I

ScanForNearestNode = CurrClosestIndex
End Function

Private Function GetDist2D(X As Long, Y As Long, X1 As Long, Y1 As Long) As Long
    GetDist2D = Sqr(((X - X1) ^ 2) + ((Y - Y1) ^ 2))
End Function

Private Sub RenderNodePoints()
Dim I As Long

picMain.DrawWidth = 4

For I = 0 To nNodes - 1
    picMain.PSet (NodeList(I).X, NodeList(I).Y), RGB(0, 0, 0)
Next I
End Sub

Private Sub RenderTreeNodes()
Dim I As Long

picMain.DrawWidth = 1

For I = 0 To nNodes - 1
    If Not (TreeNodeList(I).NextNode(0) = -1) Then picMain.Line (NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y)-(NodeList(TreeNodeList(I).NextNode(0)).X, NodeList(TreeNodeList(I).NextNode(0)).Y), RGB(0, 0, 255)
    If Not (TreeNodeList(I).NextNode(1) = -1) Then picMain.Line (NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y)-(NodeList(TreeNodeList(I).NextNode(1)).X, NodeList(TreeNodeList(I).NextNode(1)).Y), RGB(0, 0, 255)
    If Not (TreeNodeList(I).NextNode(2) = -1) Then picMain.Line (NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y)-(NodeList(TreeNodeList(I).NextNode(2)).X, NodeList(TreeNodeList(I).NextNode(2)).Y), RGB(0, 0, 255)
    If Not (TreeNodeList(I).NextNode(3) = -1) Then picMain.Line (NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y)-(NodeList(TreeNodeList(I).NextNode(3)).X, NodeList(TreeNodeList(I).NextNode(3)).Y), RGB(0, 0, 255)
Next I
End Sub

Private Sub cmdBenchmark_Click()
'//Perform several 100 tests, work out what the average time is and success rate....
Dim rndStart As Long
Dim rndEnd As Long
Dim pthSuccess As Integer, pthFail As Integer
Dim I As Long, J As Long
Dim Result As Boolean
Dim tStart As Currency, tEnd As Currency, tTime As Currency, tFreq As Currency
Dim OverallTime As Currency

'//This will test if the current graph is a complete one.
For I = 0 To nNodes - 1
    For J = 0 To nNodes - 1
    
        tStart = 0: tEnd = 0: tTime = 0
            Call QueryPerformanceCounter(tStart)
            
                Result = DijkstraPathFinding(I, J)
            
            Call QueryPerformanceCounter(tEnd)
        Call QueryPerformanceFrequency(tFreq)
        
        tTime = (tEnd - tStart) / tFreq
        OverallTime = OverallTime + tTime
        
        If Result = True Then
            pthSuccess = pthSuccess + 1
        Else
            'A very rare case: due to bad network planning
            pthFail = pthFail + 1
            Debug.Print "Could not find a path between ", rndStart, rndEnd
        End If
        DoEvents
    Next J
Next I


OverallTime = OverallTime / (nNodes * nNodes)

If OverallTime = 0 Then
    MsgBox "The Algorithm tested as being " & (pthSuccess / (nNodes * nNodes)) * 100 & "% efficient on this graph network" & vbCr & "The average processing time for traversing this network was: Unmeasurably Fast!", vbInformation, "Results."
Else
    MsgBox "The Algorithm tested as being " & (pthSuccess / (nNodes * nNodes)) * 100 & "% efficient on this graph network" & vbCr & "The average processing time for traversing this network was: " & OverallTime & " ms", vbInformation, "Results."
End If
End Sub

Private Sub cmdSearch_Click()
picMain.Cls
RenderNodePoints
RenderTreeNodes
Dim TimeTaken As Currency, TimeStarted As Currency, Freq As Currency
    Call QueryPerformanceCounter(TimeStarted)
        If DijkstraPathFinding(CurrSrcNode, CurrDestNode) = False Then GoTo BailOut:
    Call QueryPerformanceCounter(TimeTaken)
    Call QueryPerformanceFrequency(Freq)
    TimeTaken = (TimeTaken - TimeStarted) / Freq
MsgBox "Dijkstra Search took " & TimeTaken & "ms to complete"

'//For the purpose of this example we now list all the entries that we have to follow
    Dim tmpstr As String
    Dim I As Long
    For I = 1 To nPathList
        tmpstr = tmpstr & PATHLIST(I) & "-"
    Next I
    lblPath.Caption = "Path: " & Left(tmpstr, Len(tmpstr) - 1) & " (Dist: " & TreeNodeList(CurrDestNode).Distance & ")"
    DrawShortestPath
    
Exit Sub

BailOut:
    MsgBox "A path could not be found within 1 second..."
End Sub

Private Sub Form_Load()
NodeList(0).X = 10
NodeList(0).Y = 10
NodeList(1).X = 175
NodeList(1).Y = 10
NodeList(2).X = 340
NodeList(2).Y = 10
NodeList(3).X = 430
NodeList(3).Y = 10
NodeList(4).X = 470
NodeList(4).Y = 60
NodeList(5).X = 540
NodeList(5).Y = 60
NodeList(6).X = 600
NodeList(6).Y = 60
NodeList(7).X = 600
NodeList(7).Y = 110
NodeList(8).X = 30
NodeList(8).Y = 115
NodeList(9).X = 65
NodeList(9).Y = 80
NodeList(10).X = 120
NodeList(10).Y = 70
NodeList(11).X = 225
NodeList(11).Y = 90
NodeList(12).X = 315
NodeList(12).Y = 75
NodeList(13).X = 370
NodeList(13).Y = 80
NodeList(14).X = 510
NodeList(14).Y = 140
NodeList(15).X = 5
NodeList(15).Y = 170
NodeList(16).X = 140
NodeList(16).Y = 155
NodeList(17).X = 350
NodeList(17).Y = 145
NodeList(18).X = 10
NodeList(18).Y = 215
NodeList(19).X = 85
NodeList(19).Y = 190
NodeList(20).X = 200
NodeList(20).Y = 185
NodeList(21).X = 290
NodeList(21).Y = 185
NodeList(22).X = 435
NodeList(22).Y = 175
NodeList(23).X = 515
NodeList(23).Y = 180
NodeList(24).X = 600
NodeList(24).Y = 180
NodeList(25).X = 145
NodeList(25).Y = 250
NodeList(26).X = 215
NodeList(26).Y = 220
NodeList(27).X = 435
NodeList(27).Y = 215
NodeList(28).X = 515
NodeList(28).Y = 215
NodeList(29).X = 10
NodeList(29).Y = 310
NodeList(30).X = 95
NodeList(30).Y = 275
NodeList(31).X = 95
NodeList(31).Y = 310
NodeList(32).X = 160
NodeList(32).Y = 315
NodeList(33).X = 260
NodeList(33).Y = 270
NodeList(34).X = 345
NodeList(34).Y = 270
NodeList(35).X = 340
NodeList(35).Y = 315
NodeList(36).X = 430
NodeList(36).Y = 260
NodeList(37).X = 610
NodeList(37).Y = 275
NodeList(38).X = 605
NodeList(38).Y = 310
NodeList(39).X = 500
NodeList(39).Y = 310

TreeNodeList(0).CurrNode = 0
    TreeNodeList(0).NextNode(0) = 1
    TreeNodeList(0).NextNode(1) = -1
    TreeNodeList(0).NextNode(2) = -1
    TreeNodeList(0).NextNode(3) = -1
TreeNodeList(1).CurrNode = 1
    TreeNodeList(1).NextNode(0) = 0
    TreeNodeList(1).NextNode(1) = 2
    TreeNodeList(1).NextNode(2) = 11
    TreeNodeList(1).NextNode(3) = -1
TreeNodeList(2).CurrNode = 2
    TreeNodeList(2).NextNode(0) = 1
    TreeNodeList(2).NextNode(1) = 3
    TreeNodeList(2).NextNode(2) = 12
    TreeNodeList(2).NextNode(3) = -1
TreeNodeList(3).CurrNode = 3
    TreeNodeList(3).NextNode(0) = 2
    TreeNodeList(3).NextNode(1) = 4
    TreeNodeList(3).NextNode(2) = -1
    TreeNodeList(3).NextNode(3) = -1
TreeNodeList(4).CurrNode = 4
    TreeNodeList(4).NextNode(0) = 3
    TreeNodeList(4).NextNode(1) = 5
    TreeNodeList(4).NextNode(2) = -1
    TreeNodeList(4).NextNode(3) = -1
TreeNodeList(5).CurrNode = 5
    TreeNodeList(5).NextNode(0) = 4
    TreeNodeList(5).NextNode(1) = 6
    TreeNodeList(5).NextNode(2) = 14
    TreeNodeList(5).NextNode(3) = -1
TreeNodeList(6).CurrNode = 6
    TreeNodeList(6).NextNode(0) = 5 '4
    TreeNodeList(6).NextNode(1) = 7
    TreeNodeList(6).NextNode(2) = -1
    TreeNodeList(6).NextNode(3) = -1
TreeNodeList(7).CurrNode = 7
    TreeNodeList(7).NextNode(0) = 6
    TreeNodeList(7).NextNode(1) = -1
    TreeNodeList(7).NextNode(2) = -1
    TreeNodeList(7).NextNode(3) = -1
TreeNodeList(8).CurrNode = 8
    TreeNodeList(8).NextNode(0) = 9
    TreeNodeList(8).NextNode(1) = -1
    TreeNodeList(8).NextNode(2) = -1
    TreeNodeList(8).NextNode(3) = -1
TreeNodeList(9).CurrNode = 9
    TreeNodeList(9).NextNode(0) = 8
    TreeNodeList(9).NextNode(1) = 10
    TreeNodeList(9).NextNode(2) = 16
    TreeNodeList(9).NextNode(3) = -1
TreeNodeList(10).CurrNode = 10
    TreeNodeList(10).NextNode(0) = 9
    TreeNodeList(10).NextNode(1) = -1
    TreeNodeList(10).NextNode(2) = -1
    TreeNodeList(10).NextNode(3) = -1
TreeNodeList(11).CurrNode = 11
    TreeNodeList(11).NextNode(0) = 1
    TreeNodeList(11).NextNode(1) = 12
    TreeNodeList(11).NextNode(2) = 16
    TreeNodeList(11).NextNode(3) = -1
TreeNodeList(12).CurrNode = 12
    TreeNodeList(12).NextNode(0) = 2
    TreeNodeList(12).NextNode(1) = 11
    TreeNodeList(12).NextNode(2) = 13
    TreeNodeList(12).NextNode(3) = -1
TreeNodeList(13).CurrNode = 13
    TreeNodeList(13).NextNode(0) = 12
    TreeNodeList(13).NextNode(1) = 17
    TreeNodeList(13).NextNode(2) = -1
    TreeNodeList(13).NextNode(3) = -1
TreeNodeList(14).CurrNode = 14
    TreeNodeList(14).NextNode(0) = 5
    TreeNodeList(14).NextNode(1) = 23
    TreeNodeList(14).NextNode(2) = -1
    TreeNodeList(14).NextNode(3) = -1
TreeNodeList(15).CurrNode = 15
    TreeNodeList(15).NextNode(0) = 18
    TreeNodeList(15).NextNode(1) = -1
    TreeNodeList(15).NextNode(2) = -1
    TreeNodeList(15).NextNode(3) = -1
TreeNodeList(16).CurrNode = 16
    TreeNodeList(16).NextNode(0) = 9
    TreeNodeList(16).NextNode(1) = 11
    TreeNodeList(16).NextNode(2) = 19
    TreeNodeList(16).NextNode(3) = 20
TreeNodeList(17).CurrNode = 17
    TreeNodeList(17).NextNode(0) = 13
    TreeNodeList(17).NextNode(1) = 21
    TreeNodeList(17).NextNode(2) = 22
    TreeNodeList(17).NextNode(3) = -1
TreeNodeList(18).CurrNode = 18
    TreeNodeList(18).NextNode(0) = 15
    TreeNodeList(18).NextNode(1) = 19
    TreeNodeList(18).NextNode(2) = 29
    TreeNodeList(18).NextNode(3) = -1
TreeNodeList(19).CurrNode = 19
    TreeNodeList(19).NextNode(0) = 16
    TreeNodeList(19).NextNode(1) = 18
    TreeNodeList(19).NextNode(2) = 20
    TreeNodeList(19).NextNode(3) = -1
TreeNodeList(20).CurrNode = 20
    TreeNodeList(20).NextNode(0) = 16
    TreeNodeList(20).NextNode(1) = 19
    TreeNodeList(20).NextNode(2) = 21
    TreeNodeList(20).NextNode(3) = 26
TreeNodeList(21).CurrNode = 21
    TreeNodeList(21).NextNode(0) = 17
    TreeNodeList(21).NextNode(1) = 20
    TreeNodeList(21).NextNode(2) = -1
    TreeNodeList(21).NextNode(3) = -1
TreeNodeList(22).CurrNode = 22
    TreeNodeList(22).NextNode(0) = 17
    TreeNodeList(22).NextNode(1) = 27
    TreeNodeList(22).NextNode(2) = -1
    TreeNodeList(22).NextNode(3) = -1
TreeNodeList(23).CurrNode = 23
    TreeNodeList(23).NextNode(0) = 14
    TreeNodeList(23).NextNode(1) = 24
    TreeNodeList(23).NextNode(2) = 28
    TreeNodeList(23).NextNode(3) = -1
TreeNodeList(24).CurrNode = 24
    TreeNodeList(24).NextNode(0) = 23
    TreeNodeList(24).NextNode(1) = -1
    TreeNodeList(24).NextNode(2) = -1
    TreeNodeList(24).NextNode(3) = -1
TreeNodeList(25).CurrNode = 25
    TreeNodeList(25).NextNode(0) = 26
    TreeNodeList(25).NextNode(1) = -1
    TreeNodeList(25).NextNode(2) = -1
    TreeNodeList(25).NextNode(3) = -1
TreeNodeList(26).CurrNode = 26
    TreeNodeList(26).NextNode(0) = 20
    TreeNodeList(26).NextNode(1) = 25
    TreeNodeList(26).NextNode(2) = 33
    TreeNodeList(26).NextNode(3) = -1
TreeNodeList(27).CurrNode = 27
    TreeNodeList(27).NextNode(0) = 22
    TreeNodeList(27).NextNode(1) = 28
    TreeNodeList(27).NextNode(2) = 36
    TreeNodeList(27).NextNode(3) = -1
TreeNodeList(28).CurrNode = 28
    TreeNodeList(28).NextNode(0) = 23
    TreeNodeList(28).NextNode(1) = 27
    TreeNodeList(28).NextNode(2) = 37
    TreeNodeList(28).NextNode(3) = -1
TreeNodeList(29).CurrNode = 29
    TreeNodeList(29).NextNode(0) = 18
    TreeNodeList(29).NextNode(1) = 31
    TreeNodeList(29).NextNode(2) = -1
    TreeNodeList(29).NextNode(3) = -1
TreeNodeList(30).CurrNode = 30
    TreeNodeList(30).NextNode(0) = 31
    TreeNodeList(30).NextNode(1) = -1
    TreeNodeList(30).NextNode(2) = -1
    TreeNodeList(30).NextNode(3) = -1
TreeNodeList(31).CurrNode = 31
    TreeNodeList(31).NextNode(0) = 29
    TreeNodeList(31).NextNode(1) = 30
    TreeNodeList(31).NextNode(2) = 32
    TreeNodeList(31).NextNode(3) = -1
TreeNodeList(32).CurrNode = 32
    TreeNodeList(32).NextNode(0) = 31
    TreeNodeList(32).NextNode(1) = -1
    TreeNodeList(32).NextNode(2) = -1
    TreeNodeList(32).NextNode(3) = -1
TreeNodeList(33).CurrNode = 33
    TreeNodeList(33).NextNode(0) = 26
    TreeNodeList(33).NextNode(1) = 34
    TreeNodeList(33).NextNode(2) = -1
    TreeNodeList(33).NextNode(3) = -1
TreeNodeList(34).CurrNode = 34
    TreeNodeList(34).NextNode(0) = 33
    TreeNodeList(34).NextNode(1) = 35
    TreeNodeList(34).NextNode(2) = 36
    TreeNodeList(34).NextNode(3) = -1
TreeNodeList(35).CurrNode = 35
    TreeNodeList(35).NextNode(0) = 34
    TreeNodeList(35).NextNode(1) = -1
    TreeNodeList(35).NextNode(2) = -1
    TreeNodeList(35).NextNode(3) = -1
TreeNodeList(36).CurrNode = 36
    TreeNodeList(36).NextNode(0) = 27
    TreeNodeList(36).NextNode(1) = 34
    TreeNodeList(36).NextNode(2) = -1
    TreeNodeList(36).NextNode(3) = -1
TreeNodeList(37).CurrNode = 37
    TreeNodeList(37).NextNode(0) = 28
    TreeNodeList(37).NextNode(1) = 38
    TreeNodeList(37).NextNode(2) = -1
    TreeNodeList(37).NextNode(3) = -1
TreeNodeList(38).CurrNode = 38
    TreeNodeList(38).NextNode(0) = 37
    TreeNodeList(38).NextNode(1) = 39
    TreeNodeList(38).NextNode(2) = -1
    TreeNodeList(38).NextNode(3) = -1
TreeNodeList(39).CurrNode = 39
    TreeNodeList(39).NextNode(0) = 38
    TreeNodeList(39).NextNode(1) = -1
    TreeNodeList(39).NextNode(2) = -1
    TreeNodeList(39).NextNode(3) = -1
    
    
'//Fill out the edge weighting information...
Dim I As Long
For I = 0 To nNodes - 1
        If Not (TreeNodeList(I).NextNode(0) = -1) Then TreeNodeList(I).Dist(0) = GetDist2D(NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y, NodeList(TreeNodeList(I).NextNode(0)).X, NodeList(TreeNodeList(I).NextNode(0)).Y)
        If Not (TreeNodeList(I).NextNode(1) = -1) Then TreeNodeList(I).Dist(1) = GetDist2D(NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y, NodeList(TreeNodeList(I).NextNode(1)).X, NodeList(TreeNodeList(I).NextNode(1)).Y)
        If Not (TreeNodeList(I).NextNode(2) = -1) Then TreeNodeList(I).Dist(2) = GetDist2D(NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y, NodeList(TreeNodeList(I).NextNode(2)).X, NodeList(TreeNodeList(I).NextNode(2)).Y)
        If Not (TreeNodeList(I).NextNode(3) = -1) Then TreeNodeList(I).Dist(3) = GetDist2D(NodeList(TreeNodeList(I).CurrNode).X, NodeList(TreeNodeList(I).CurrNode).Y, NodeList(TreeNodeList(I).NextNode(3)).X, NodeList(TreeNodeList(I).NextNode(3)).Y)
Next I


picMain.Cls
RenderNodePoints
RenderTreeNodes
End Sub

Private Sub picMain_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim ClosestNode As Long
ClosestNode = ScanForNearestNode(CLng(X), CLng(Y))

lblVisitNumber.Caption = "Visit Number: " & TreeNodeList(ClosestNode).VisitNumber
lblVisitDistance.Caption = "Distance: " & TreeNodeList(ClosestNode).Distance
lblTmpVar.Caption = "Temp Var: " & TreeNodeList(ClosestNode).TmpVar

If Button = 1 Then
    lblClosestSrc.Caption = "Closest Node To Src: " & ClosestNode
    CurrSrcNode = ClosestNode
    shpSourceNode.Left = NodeList(ClosestNode).X - 12
    shpSourceNode.Top = NodeList(ClosestNode).Y - 12
ElseIf Button = 2 Then
    lblClosestDest.Caption = "Closest Node To Dest: " & ClosestNode
    CurrDestNode = ClosestNode
    shpDestNode.Left = NodeList(ClosestNode).X - 12
    shpDestNode.Top = NodeList(ClosestNode).Y - 12
End If
End Sub
